;==============================================================================
;		     DS1307
; 		 : temp, temp1, R0, R1.
;==============================================================================
;			     7-   . 00
;------------------------------------------------------------------------------
DS_Start:
		rcall IIC_Start				;  
		ldi temp,0xD0				; 
		rcall iic_send				;  
		ldi temp,0x00 				;  
		rcall iic_send				;  . 
		
		rcall IIC_Start				;   
		ldi temp,0xD1				;    
		rcall iic_send				;  
		rcall iic_recieve_lst  		;  ..
		cbr temp,0b10000000 		; 7- .
		push temp 					; temp  
		rcall IIC_Stop 				;  
		
		rcall IIC_Start				;  
		ldi temp,0xD0 				;  +  
		rcall iic_send				;  
		ldi temp,0  				;  .
		rcall iic_send				;  . 
		pop temp					; temp  
		rcall iic_send				; 0- 
		rcall IIC_Stop				;  
		
		ret
;==============================================================================
;			    7-   . 00
;------------------------------------------------------------------------------
DS_stop:
		rcall IIC_Start				;  
		ldi temp,0xD0 				;  +  
		rcall iic_send				;  
		ldi temp,0x00 				;  
		rcall iic_send				;  . 
		
		rcall IIC_Start				;    
		ldi temp,0xD1		 		;    
		rcall iic_send				;  
		rcall iic_recieve_lst  		;  ..
		sbr temp,0b10000000 		; 7- .
		push temp 					; temp  
		rcall IIC_Stop 				;  
		
		rcall IIC_Start				;  
		ldi temp,0xD0 				;  +  
		rcall iic_send				;  
		ldi temp,0  				;  .
		rcall iic_send				;  . 
		pop temp					; temp  
		rcall iic_send				; 0- 
		rcall IIC_Stop				;  
		ret
;==============================================================================
;	   24-  .    .
;	      . :
;	 T_clk - ,  T_clk+1 -    T_clk+2 - 
;------------------------------------------------------------------------------
DS_Set_time:
		rcall IIC_Start				;  
		
		ldi temp,0xD0		 		;  +  
		rcall iic_send				;
		ldi temp,0  				;  .
		rcall iic_send				;
		lds temp,T_clk				;   . 
		rcall iic_send 				;  
		lds temp,T_clk+1			;   . 
		rcall iic_send 				;  
		lds temp,T_clk+2			;   . 
		rcall iic_send 				;  
		
		rcall IIC_Stop 				;  
		
		ret
		
;==============================================================================
;		    DS1307 
;	     .   T_clk
;------------------------------------------------------------------------------
DS_get_time:
		rcall IIC_Start				;  
		ldi temp,0xD0		 		;  +  
		rcall iic_send				;  
		ldi temp,0x00 				;   DS1307
		rcall iic_send				;  . 
		
		rcall IIC_Start				;   
		ldi temp,0xD1		 		;    
		rcall iic_send				;  
		
		rcall iic_recieve  			; 
		cbr temp,7					; 7- .
		sts T_clk,temp				;   
		
		rcall iic_recieve  			; 
		sts T_clk+1,temp			;    
		
		rcall iic_recieve_lst  		; 
		sts T_clk+2,temp			;   
		
		rcall IIC_Stop 				;  
		ret
		
;==============================================================================
;		    DS1307
;	     .   D_clk
; D_clk - ,  D_clk+1 -    D_clk+2 -  ( 2 )
;------------------------------------------------------------------------------
DS_get_date:
		rcall IIC_Start				;  
		ldi temp,0xD0		 		;  
		rcall iic_send				;  
		ldi temp,0x04 				;  
		rcall iic_send				;  . 
		rcall IIC_Start				;   
		ldi temp,0xD1		 		;    
		rcall iic_send
		
		rcall iic_recieve  			; 
		sts D_clk,temp				;   
		
		rcall iic_recieve  			; 
		sts D_clk+1,temp			;   
		
		rcall iic_recieve_lst  		; 
		sts D_clk+2,temp			;   
		
		rcall IIC_Stop 				;  
		ret

;==============================================================================
;		 .    .
;	      . :
; D_clk - ,  D_clk+1 -    D_clk+2 -  ( 2 )
;------------------------------------------------------------------------------
DS_Set_date:
		rcall IIC_Start				;  
		
		ldi temp,0xD0		 		;  +  
		rcall iic_send
		ldi temp,4  				;  .
		rcall iic_send
		
		lds temp,D_clk				;
		rcall iic_send 				;  
		lds temp,D_clk+1			;
		rcall iic_send 				;  
		lds temp,D_clk+2			;
		rcall iic_send 				; 
		
		rcall IIC_Stop 				;  
		
		ret
		
;==============================================================================
;		   RTC  1 
;------------------------------------------------------------------------------
 out_1Hz:
		rcall IIC_Start				;  
		ldi temp,0xD0				; 
		rcall iic_send				;  
		ldi temp,0x07  				;  .
		rcall iic_send				;  . 
		ldi temp,0x10				; 
		rcall iic_send				;  1 
		rcall IIC_Stop				;  
		ret
;==============================================================================
; 8- HEX-   BCD-
;: HEX  temp, : BCD  temp
;     HEX-  0  99
;-----------------------------------------------------------------------
 HEX_BCD:	push temp1			;
 			clr temp1			; MSB
 bBCD8_1:	subi temp,10		; 10
 			brcs bBCD8_2		;,  . 
 			inc temp1			; MSB
 			rjmp bBCD8_1		;   
 bBCD8_2:	subi temp,-10		;  
 			swap temp1			;
 			or temp,temp1		;  BCD-
 			pop temp1			;
 			ret					;
			
;=======================================================================
;   BCD  HEX-,
;: BCD  temp, : HEX  temp
;temp1 -     
; R0, R1 -  
;-----------------------------------------------------------------------
 BCD_HEX:	push temp1				;
 			push R0					;
 			push R1					;
 			push temp				;  
 			ldi temp1,10			;  10
			andi temp,0b11110000	;  
			swap temp				;    
			mul temp,temp1			;  10,   R1:R0
			pop temp				;  
			andi temp,0b00001111	;  
			add temp,R0				;  HEX-
			pop R1					;
			pop R0					;
			pop temp1				;
			ret						;
			
;=======================================================================


	.EXIT
	
