;===========================================================================
;		   DS18B20
;   PC1 -    
;===========================================================================
;	.def	temp  = R16		; 
;	.def	temp1 = R17		; 
;	.def 	temp2 = R18		;  
;	.def  	temp3 = R19		;.  
;	.def	znak  = R20		;.  
	
	.def   digit1	= R25	;  
	.def   digit2	= R26	;  
	.def   digit3	= R27	;  
	.def   digit4	= R28	;   
	.def ds_command = R29	;  
	
	;   DS18B20  
	.equ DS_port  = PORTC	;,    
	.equ DS_ddr	  = DDRC	;   
	.equ DS_pin	  = PINC	;   
	.equ DS		  = PC1		; -   
	
;===========================================================================*
DS_sensor:
		rcall 	ds_reset 				;   
		ldi 	ds_command, 0xCC		;  
		rcall 	ds_write 				;
		ldi 	ds_command, 0x44 		;  
		rcall 	ds_write 				;
		
		DELAY 25						; 760 
 		
		rcall 	ds_reset 				;   
		
		ldi 	ds_command, 0xCC		;  
		rcall 	ds_write
		
		ldi 	ds_command, 0xBE 		; ,  
		rcall 	ds_write 				;
		
		ldi		temp, 5					;
		rcall	ds_delay				;  
		
		rcall 	ds_read					;  8 
		
		ret
		
;===========================================================================
;	   
; :   temp     2,75  
;---------------------------------------------------------------------------
ds_delay:
	;	ldi 	temp2, 2			; Fclk = 4 MHz
		ldi 	temp2, 4			; Fclk = 8 MHz
 cycle:	nop
		dec 	temp2
		brne	cycle
		dec 	temp
		brne	ds_delay
		ret
		
;===========================================================================
;		  
;---------------------------------------------------------------------------
ds_reset:
		cbi	 	DS_port,DS
		ldi		temp, 0x02			; DS_port.1   
		out		DS_ddr, temp
		
		ldi 	temp,220			;  600
		rcall 	ds_delay
		
		ldi		temp, 0				; DS_port.1 
		out		DS_ddr, temp
		
		ldi 	temp,220 			;    600
		rcall 	ds_delay
		ret

;============================================================================
;		  
;    ds_command      .
;----------------------------------------------------------------------------
ds_write:
		ldi 	temp1,8				;  
	wr_loop:
		lsr 	ds_command			;.  0  -> CF
		brcs 	one_wr				; CF=1,    ,
		rjmp 	zero_wr				; ,  
	
	one_wr:		; 
		cbi 	DS_port, DS			;
		ldi 	temp, 0x02			;
		out		DS_ddr, temp		;DS_port.DS   
		
		ldi 	temp, 1				;  2,7
		rcall 	ds_delay 			;
		
		ldi		temp, 0				;DS_port.DS   
		out		DS_ddr, temp		;
		
		ldi 	temp,20 			;  60 -  "1"
		rcall 	ds_delay			;
		rjmp 	wr_lab				;
		
	zero_wr:	; 
		cbi 	DS_port, DS			;
		ldi 	temp, 0x02			;
		out		DS_ddr, temp		;DS_port.DS   
		
		ldi 	temp, 26			;   70
		rcall 	ds_delay 			;
		
		ldi		temp, 0				;DS_port.DS   
		out		DS_ddr, temp		;
		
  wr_lab:
		ldi 	temp, 1				;     2,7
		rcall 	ds_delay			;
		dec 	temp1				;    ,
		brne 	wr_loop				;   
		
		ret
;===========================================================================
;		  
;      temp3     .
;   znak  digit1     .
;---------------------------------------------------------------------------
ds_read:
		ldi temp1, 9				;  
		ldi temp3, 0				;  
		
		; 1
		cbi DS_port,DS				;
		ldi temp, 0x02				;DS_port.DS   
		out DS_ddr, temp				;
		
		ldi temp,2					;
		rcall ds_delay				;  2,7
		
		ldi temp, 0 				;DS_port.DS   
		out DS_ddr, temp 			;
		
		ldi temp, 3					;
		rcall ds_delay				; 8
		ldi temp, 22				; 60
		rcall ds_delay				;
		
		;2
		cbi DS_port,DS				;
		ldi temp, 0x02				;DS_port.DS   
		out DS_ddr, temp			;
		
		ldi temp,2					;
		rcall ds_delay				;  2,7
		
		ldi temp, 0 				;DS_port.DS   
		out DS_ddr, temp 			;
		
		ldi temp, 3					;
		rcall ds_delay				; 8
		ldi temp, 22				; 60
		rcall ds_delay				;
		
		;3
		cbi DS_port,DS				;
		ldi temp, 0x02				;DS_port.DS   
		out DS_ddr, temp			;
		
		ldi temp,2					;
		rcall ds_delay				;  2,7
		
		
		ldi temp, 0					;DS_port.DS   
		out DS_ddr, temp 			;
		
		ldi temp, 3					;
		rcall ds_delay				; 8
		ldi temp, 22				; 60
		rcall ds_delay				;
		
rd_lab:
		cbi DS_port,DS				;
		ldi temp, 0x02				;DS_port.DS   
		out DS_ddr, temp			;
		
		ldi temp,2					;
		rcall ds_delay				;  2,7
		
		ldi temp, 0 				;DS_port.DS   
		out DS_ddr, temp 			;
		
		ldi temp, 3					;
		rcall ds_delay				; 8
		
		cpi temp1, 1				;    8 , -
		breq sign					;    
		
		sbis DS_pin, DS				; DS=1   .  1, -
		rjmp zero_r					; ,   .  0
		
 one_r:		;  
		lsr temp3					;  
		ori temp3,0x80				;   . 
		rjmp lab_rd					;
		
 zero_r:	;  
		lsr temp3					;  
		nop							;
		
 lab_rd:	;  
		ldi temp, 22				;  60
		rcall ds_delay				;
		
		dec temp1					;    ,-
		brne rd_lab					;     
		
  sign:		;  
		ldi znak, 0xFF				;
		sbis DS_pin, DS				; DS=1   . .
		ldi znak, 0					; ,-   
		
		nop							;
		ldi temp, 22				;  60
		rcall ds_delay				;
		
		ldi digit1, -3				;   
		
		ret							;
		
;==============================================================================
;			- 
;	     temp3  znak
;------------------------------------------------------------------------------
bcd_convert:
		;   
		clr digit1					;  
		clr digit2					;  
		clr digit3					;  
		clr digit4					;   
		
		cpi znak, 0					;  ,
		breq plus					;   
		
		com temp3					;  ,
		inc temp3					;    1 
		ldi digit1, -3				;  "-"   

plus:	mov temp, temp3   			; .   temp
		lsr temp   					; 
			;  100
  M1:	cpi temp,100   				;   100,
		brge M2   					;    , -
		rjmp M3   					; ,   
  M2:	inc digit1					;   
		subi temp,100				;    
		rjmp M1						;   100
			;  10
  M3:	cpi temp,10					;   10,
		brge M4   					;    , -
		rjmp M5   					; ,   
  M4:	inc digit2					;   
		subi temp,10				;    
		rjmp M3						;   10
			; 
  M5:	cpi temp,1					;   1,
		brge M6   					;    , -
		rjmp M7   					; ,    
  M6:	inc digit3					;   
		dec temp					;    
		rjmp M5						;  
			;   (  0,5)
  M7:	mov temp, temp3				; .   temp
		andi temp,1					;   . 
		sbrs temp, 0 				;  , 
		rjmp M8						;    ASCII ,
		subi digit4, -5				; , -  5  4- 
		;
;---------------------------------------------------------------------------
;		   ASCII     
;---------------------------------------------------------------------------
	M8:
		cpi digit1, 0			;    0, 
		brne M9					;   ,  -
		ldi digit1, 0xF0		;0xF0 + 0x30 = 0x20 -  
		cpi digit2, 0			;    0, 
		brne M9					;  ,  -
		ldi digit2, 0xF0		;0xF0 + 0x30 = 0x20 -  
		
	M9:
		cpi digit1, -3			;0xFD + 0x30 = 0x2D (-)    ,  
		brne M10				;  ASCII 
		cpi digit2, 0			;    0,  
		brne M10				;  ASCII ,  -
		ldi digit2, 0xF0		;0xF0 + 0x30 = 0x20 -  
		
	M10:	;  ASCII  
		subi digit1, -48		; 0x30
		subi digit2, -48		; 0x30
		subi digit3, -48		; 0x30
		subi digit4, -48		; 0x30
		
		ret
		
;===========================================================================
;		   
;---------------------------------------------------------------------------
Prnt_Temp:
		
		POZ_LCD 0,4					;0- , 4- 
		mov temp, digit1			;  
		rcall lcd_put_char			;
		mov temp, digit2			;
		rcall lcd_put_char			;
		mov temp, digit3			;
		rcall lcd_put_char			;
	;	ldi temp, 0x2c				;
	;	rcall lcd_put_char			;
	;	mov temp, digit4			; 
	;	rcall lcd_put_char			;
		
		ldi temp, 0x91				;
		rcall lcd_put_char			;
		ldi temp, 0x43				; 
		rcall lcd_put_char			;
		DELAY 10					; 323 
		
		ret
		
;---------------------------------------------------------------------------
