;=============================================================================
; 	 - Nokia5110 (Nokia3310) 4884 .
;	  PCD8544.
;	:   
;-----------------------------------------------------------------------------
;  : R0, R6, R16, R17, R18, ZL, ZH
;=============================================================================
;		  :
; Command 0x20		 (PD=0, V=0, H=0) . ; .  
; Command 0x21		 (PD=0, V=0, H=1) . ; .  
; Command 0x28...0x2F		   (PD=1)
; Command 0x08				  -   
; Command 0x09				׸  -   
; Command 0x0				   
; Command 0x0D				  
; Command 0x40...0x45		 Y- = 0...8 -> 0x40... 0x45
; Command 0x80...0xD3 		 X- = 0...83  -> 0x80...0xD3
; Command 0x04...0x07		  
; Command 0x10...0x17		   (BS0...BS2)
; Command 0x80...0xFF		  (  (Vop))
;							 -     0xAA...0xDC
;=============================================================================
	;  LCD  
	.equ LCD_DC_port  = PORTB
	.equ LCD_DC   = 1			;  - /  PORTB.1
	.equ LCD_SCE_port = PORTB
	.equ LCD_SCE  = 2			; .    PORTB.2
	.equ LCD_SDIN_port = PORTB
	.equ LCD_SDIN = 3			;   PORTB.3
	.equ RES_port = PORTB
	.equ RES 	  = 4			;    PORTB.4
	.equ LCD_SCLK_port = PORTB
	.equ LCD_SCLK = 5			;   PORTB.5
	
	.def fnt_d = R15			; : 0 -  1 - 
;      SREG -    .
;           .
;         
;  fnt_d ,   0.

	.DSEG					;   SRAM ()
	str_num: 	.byte 1		;   Y
	poz_num:	.byte 1  	;    X
	.CSEG					;
;==============================================================================
;		    LCD
;------------------------------------------------------------------------------
lcd_init_tab: 
		.db 0x21, 0xBC, 0x06, 0x13, 0x20, 0x0C
		; 0x21 ; (PD=0, V=0, H=1) . ; .  
		; 0xBC ;  (Vop) 0xC8 - !  (0xBC)
		; 0x06 ;   (Temp coefficent)
		; 0x13 ;  (LCD bias mode(n=4) 1:48)
		; 0x20 ; (PD=0, V=0, H=0) . ; .  
		; 0x0C ;  ..   (D=1, E=0)
;==============================================================================
;			 
;------------------------------------------------------------------------------
lcd_init: 
		sbi RES_port,RES				;   RES
		DELAY 1							;  32 
		cbi LCD_SCE_port,LCD_SCE		;  (SCE=0)
		rcall Delay2					; 10 
			;   LCD
		cbi RES_port,RES				;   LCD
		DELAY 1							;   32 
		sbi RES_port,RES				;   LCD
		;
		rcall Delay2					; 10 
		sbi LCD_SCE_port,LCD_SCE		;  (SCE=0)
		DELAY 1							;  32 
		;
		ldi ZL,low(lcd_init_tab*2) 		;   
		ldi ZH,high(lcd_init_tab*2) 	;
		ldi R17,6 						;-  = 6
		
lp_in:	lpm 							;   
		mov temp,R0						;
		rcall lcd_cmd       			;    
		adiw ZL,1 						;  
		dec R17							;
		brne lp_in						;
		
		rcall lcd_clr					;    
		clr fnt_d						;  
		clt								; 
		DELAY 1							;
		ret								; 
		
;================================================================================
;				 
;--------------------------------------------------------------------------------
clr_line:              ;  
		ldi ZL,low (84)			;   
		ldi ZH,high(84)			;
		ldi temp,0				;   
		rjmp clr_c				;    
lcd_clr:               ; 
		ldi temp,0				;   1- 
		rcall lcd_X				;
		ldi temp,0				;  1- 
		rcall lcd_Y				;
		
		ldi ZL,low (504)		;    84*6 = 504
		ldi ZH,high(504)		; 
		ldi temp,0				;   
clr_c:                 ;  
		rcall lcd_data			;     
		sbiw ZL,1				;  
		brne clr_c				;    0 -    
		ret						;
		
;================================================================================
;		     .
;	      temp
;--------------------------------------------------------------------------------
lcd_cmd:     ;  
		cbi LCD_SCE_port,LCD_SCE 		;  (SCE=0)
		cbi LCD_DC_port,LCD_DC 			; D/C =0   
		rjmp trd_clk					;
		
lcd_data:    ;  
		cbi LCD_SCE_port,LCD_SCE 		;  (SCE=0)
		sbi LCD_DC_port,LCD_DC 			; D/C =   
		
trd_clk:	;
		cbi LCD_SCLK_port,LCD_SCLK 		;  SCLK
		cli
		push temp2           			;   temp2
		push temp            			;   temp
		rcall delay1					; 
		ldi temp2,8         			;  
 out_byte:    	;    
		rcall delay1					; 
		sbrs temp,7          			;   = 0
		cbi LCD_SDIN_port,LCD_SDIN		;DATA -> 0
		sbrc temp,7          			;   = 1,-  -
		sbi LCD_SDIN_port,LCD_SDIN		;DATA -> 1   
		rcall delay1					; 
				;  
		sbi LCD_SCLK_port,LCD_SCLK		;CLK -> 1    
		rcall delay1					; 
		cbi LCD_SDIN_port,LCD_SDIN		;DATA -> 0
		rcall delay1					; 
		cbi LCD_SCLK_port,LCD_SCLK    	;CLK -> 0   
		
		rcall delay1					; 
		rol temp            			;   temp = <<1 
		dec temp2          				;  
		brne out_byte        			;  ,    
		;
		sbi LCD_SCE_port,LCD_SCE 		;  (SCE=1)
		sbi LCD_DC_port,LCD_DC 			; D/C =1   
		
		pop temp            		; temp  
		pop temp2           		; temp2  
		sei
		ret                    		;

;=======================================================================================
;	       6x8 
;  R16 -       ASCII 
;  R17 -    
;---------------------------------------------------------------------------------------
lcd_put_char:
		cli
		push  temp             	;
		push  R17				;
		push  ZL               	;
		push  ZH               	;
		;    
		cpi temp,168					;    
		brne  fnt_3						;
		subi temp,(40)					;    
		rjmp fnt_1						;
fnt_3:	cpi temp,184					;    
		brne  fnt_2						;
		subi temp,(55)					;    
		rjmp fnt_1						;
		
fnt_2:	cpi R16,150						;    150
		brmi fnt_1						;    
		subi R16,160					;
		ldi ZL,low(Rus*2-32*6) 			; .  
		ldi ZH,high(Rus*2-32*6) 		;    
		rjmp chr_adr
		
fnt_1:	ldi ZL,low(font_tab*2-32*6) 	; .  
		ldi ZH,high(font_tab*2-32*6) 	;   
		
chr_adr:
		clr R17 						;
		;  ,   6
		lsl R16 						;    2
		rol R17 						;
		add ZL,R16 						;  . 
		adc ZH,R17 						;
		lsl R16 						;    4
		rol R17 						;
		add ZL,R16 						;  . 
		adc ZH,R17 						;
		
		; 6   ASCII
		ldi R17,6  	        		;     
  snd_6b:
		lpm temp,Z+          		;    
		brtc PC+2					;   
		com temp					;  
		rcall lcd_data         		;   
		;  
		sbrs fnt_d,0				; .   ,-
		rjmp chr_x1					;   
		rcall lcd_data         		;   
  chr_x1:
		dec R17	            	;   ,
		brne snd_6b          	;    ,  
		;
		pop   ZH               	;
		pop   ZL               	;
		pop   R17            	;
		pop   temp            	;
		
		sei                    	;
		ret                    	;
		
;==================================================================================
;       ASCII    68 
; 	        0.	()
; 	  Z -   ;
;-----------------------------------------------------------------------------------
	Str_LCD:
		cli
		push ZL					;   
		push ZH					;  
next:	lpm 					;  
		tst r0					;    0,  -
		breq w_str				;  
		mov temp,r0				;
		rcall lcd_put_char		;   LCD
		adiw Z,1				;   .
		rcall delay2
		rjmp next
		
w_str:	pop ZH					;  
		pop ZL					;  
		
		sei
 		ret
		
;=======================================================================================
;     17   (2,125 )    RCALL  RET
;---------------------------------------------------------------------------------------
delay1:		push r16		;
			ldi r16,1		;  
			dec r16			; 
			brne PC-1		;  
			pop r16			;
			ret
;=============================================================================
; 	     10  c   RCALL  RET
;---------------------------------------------------------------------------------------
delay2:		push r16		;
			ldi r16,23		;  
			dec r16			; 
			brne PC-1		;  
			pop r16			;
			ret
			
;============================================================================
;		     ( )
; :   R16 = X    0...13
;----------------------------------------------------------------------------
lcd_X_1: 	
		push R18					;
		ldi R18,5           		;    
		rjmp PC+3					;
lcd_X: 	push R18					;
		ldi R18,6           		;    
		cli							;
		push R0						;
 		push R1						;
		sts poz_num,R16				;     
		muls R16,R18           		;   
 		mov R16,R0					;   R0
		ori R16,0x80 				;   
		rcall lcd_cmd 				; 
		rcall delay1				; 
 		pop R1						;
		pop R0						;
		pop R18						;
		sei
 		ret
 		
;=============================================================================
;		    ( Y)
; :   R16 = Y    0...5
;-----------------------------------------------------------------------------
lcd_Y: 	cli
		sts str_num,R16					;     
		ori R16,0x40 					;   Y
		rcall  lcd_cmd         			;
 		rcall delay1					; 
 		sei
		ret
		
;============================================================================
;		     LCD
;[ R16 = X,     1
;----------------------------------------------------------------------------
lcd_XY: cli
		sbrs R16,7 					;   = 0,
		ori R16,0x40 				;     Y,
		rcall  lcd_cmd         		;
 		rcall delay1				; 
 		sei
		ret
		
;===============================================================================
;			      
;	temp -  (ASCII) 
;  temp1 -   , R6 - c   
;-------------------------------------------------------------------------------
 Dig_x2:
		push temp1					;
		;    
		ldi ZL,LOW((font_9x16)*2)	;  1-  
		ldi ZH,HIGH((font_9x16)*2)	; .  
		tst R16						;   0, 
		breq rec_9b					;   
ad_dg:	adiw Z,18					;   
		dec R16						;   , -
		brne ad_dg					;  . 
		;
		;  LCD  9   
rec_9b:	ldi temp1,9          		;   
		lpm							;      R0
		mov temp,R0					;    temp
		rcall lcd_data        		;     
		adiw Z,1					;    
		dec temp1					; 
		brne PC-5					;,     
		;
		;     
		mov R16,R6					;
		rcall lcd_X					;    
		ldi R16,2					;
		rcall lcd_Y					;  2 
		
		;  LCD  8  
		ldi temp1,8          		;   
		lpm							;      R0
		mov temp,R0					;    temp
		rcall lcd_data        		;     
		adiw Z,1					;    
		dec temp1					; 
		brne PC-5					;,     
		
		;     
		inc R6						;  
		inc R6						;    
		mov R16,R6					;
		rcall lcd_X					;    
		ldi R16,1					;
		rcall lcd_Y					;  2 
		
		pop temp1					;
		ret                    		; 

;================================================================================
;			    9  16 
;	temp -  (ASCII) 
;  temp1 -   , R6 - c   
;-------------------------------------------------------------------------------
 Dig_Clk:
		;    
		ldi ZL,LOW((Font_Clock)*2)	;  1-  
		ldi ZH,HIGH((Font_Clock)*2)	; .   0
		tst R16						;   0, 
		breq rc_9b					;   
ad_dig:	adiw Z,18					;   
		dec R16						;   , -
		brne ad_dig					;  . 
		;
		;  LCD  8   
rc_9b:	ldi temp1,9          		;   
		lpm							;      R0
		mov temp,R0					;    temp
		rcall lcd_data        		;     
		adiw Z,1					;    
		dec temp1					; 
		brne PC-5					;,     
		;
		;     
		mov R16,R6					;
		rcall lcd_X_1				;    
		ldi R16,4					;
		rcall lcd_Y					;  4 
		
		;  LCD  9  
		ldi temp1,8          		;   
		lpm							;      R0
		mov temp,R0					;    temp
		rcall lcd_data        		;     
		adiw Z,1					;    
		dec temp1					; 
		brne PC-5					;,     
		
		;     
		inc R6						;  
		inc R6						;    
		mov R16,R6					;
		rcall lcd_X_1				;    
		ldi R16,3					;
		rcall lcd_Y					;  3 
		
		ret                    		; 

;=============================================================================
	.include "Font_6x8a.asm" 		;   
;=============================================================================


	.EXIT