
;*******************************************************************************
;				Radio_Clock_Temp.asm
;	FM-   RDA5807M  LCD- Nokia5110    DS1307.
;  ATMEGA8    .  8 .
; 		  :
;-*-  ,    DS18B20.
;-*-        .
;-*-           CH+.
;-*-  ,         , 
;             CH+  CH-.
;-*-           
;          CH-.
;-*-        .
;-*-      .
;-*-        .
;-*-       .
;-*-        EEPROM    .
;-*-         V+  V-.
;-*-       00.
;-*-        0  16.
;-*-       .
;-*-  "-"   ,   .
;-*-      ,   .
;-*-             10 
;-*-     .
;
;  :
; PB0 - .   -
; PB1 - D/C     (1)   (0) LCD
; PB2 -     (0) LCD
; PB3 - DIN   LCD
; PB4 - RES   LCD (0)
; PB5 - CLK   LCD
; PB6 - 
; PB7 - 
;
; PC0 -      
; PC1 -  -    DS18B20
; PC4 - (SDA) -    I2C
; PC5 - (SCL) -    I2C
;
; PD0 -  V+
; PD1 -  V-
; PD2 -    1    
; PD3 -  CH+
; PD4 -  CH-
; PD5 -        
; PD6 -     
; PD7 -     
;
;*******************************************************************************
	;     /
    .NOLIST                 ; 
	.include "m8def.inc"	;   - ATMega8
    .LIST                   ; 
    .device ATmega8         ; 
  	;   
  	.def s_tm  = R7 		;  . 
	.def temp  = r16 		;
	.def temp1 = r17 		; 
	.def temp2 = r18 		; 
	.def temp3 = r19 		;  
	.def znak  = r20 		;  
	.def time  = r21		;  
	.def F_3H  = r22		;.   
	.def F_3L  = r23		;.   
	.def freq  = r24		;   ( )
	
	.equ Tm_l  = 255		;  
	;      
;	.equ Typ_Bat = 0		; : "0" - 3..5
	.equ Typ_Bat = 1		; : "1" - 6...10

;===============================================================================
	.DSEG					;   SRAM ()
	.ORG 0x060				;   
	decnum: 	.BYTE 5		;A    
	seek_fm:	.byte 1		;  
	read_fm:	.byte 1 	; ()  
	level:		.byte 1		; 
	volume:		.byte 1		;
	akkum:		.byte 2		; 
	T_clk:		.byte 3		; 
	prv_T:		.byte 3		; 
	D_clk:		.byte 3		; 
	Gradus:		.byte 1		; 
;=============================================================================
	.ESEG					;   EEPROM
	 R_cnfg:	.BYTE 1 	;  
	 Fst_EE:	.BYTE 1 	;   ( )
	 Vol_EE:	.BYTE 1 	; 
	 kontrast:	.BYTE 2 	;  
;=============================================================================
;----------------------------------------------------------------------
	.MACRO DELAY					; 1   32 
		ldi time,@0					;    0
 		tst time					;,  0  R21  0
		brne PC-1					;
	.ENDMACRO
	
	.MACRO LOAD_ADDR 		 		;   16- 
		ldi @0l,low(@1)   			;: LOAD_ADDR Z,12365
		ldi @0h,high(@1)  			;
	.ENDMACRO
		
	.MACRO 	POZ_LCD					;    LCD:
		ldi temp,@0					;    ,
		rcall lcd_X					;
		ldi temp,@1					;   
		rcall lcd_Y					;
	.ENDMACRO						;: POZ_LCD 12,5
	
;=============================================================================
	.CSEG				;  
	.ORG 0 				; 
	rjmp RESET			;Reset
	rjmp INT_0			;  INT 0
	reti				;  INT 1
	reti				; / 2  
	rjmp OVF_T2			; / 2  
	reti  				; / 1   
	reti				; / 1     
	reti				; / 1     
	reti				; / 1  
	rjmp OVF_T0			; / 0  
	reti				;  SPI 
	reti				; UART   
	reti				; UART   
	reti				; UART  
	reti 				;   
	reti				; EEPROM 
	reti				;   
	reti    			;  - 2- 
	reti				; SPM
	
;============================================================================
RESET:	;   ,  
		;  
		LDI 	Temp, LOW(RAMEND)
		OUT 	SPL, Temp
		LDI 	Temp, HIGH(RAMEND)
		OUT 	SPH, Temp
		CLI							;   
;-----------------------------------------------------------------------------
		;  B,  .  LCD-
	 	ldi temp,0b01111111			;
		out DDRB,temp   			;      
		ldi temp,0b11000110			;   RES  SE 
		out PORTB,temp   			;
			;  
	 	ldi temp,0b00000000			;     
		out DDRC,temp   			;
		ldi temp,0b00110000			;
		out PORTC,temp   			;  
			;  D  .  
	 	ldi temp,0b11000000			;   D
		out DDRD,temp				;
		ldi temp,0b01111111			;
		out PORTD,temp				;  
			; 
		;  :
		; (1/8000000)*1024)*256=0,032768  = 32,768   . 1/1024
		clr temp					;   
		out TCNT0,temp				;
		out TCNT2,temp				;
		ldi temp,(1<<TOIE2)|(1<<TOIE0)	; .  2  0
		out TIMSK,temp				;
		ldi temp,0b00000101			;  0   1/1024
		out TCCR0,temp				;
		;  
		ldi temp,0b00000011			;    INT0
		out MCUCR,temp				;
		sei                         ;  
		
		; 
		ldi temp,0b10000111 		;
		out ADCSRA,temp				; . . 
		ldi temp,0b11000000 		;
		out ADMUX,temp				; VREF = 2,56 ,  . ADC0
		
;===================   ==================================
		sbi PORTB,PB6				; 
				; LCD 
		rcall lcd_init				; LCD 
		LOAD_ADDR Y,kontrast+1		;.  Y .. 
		rcall Rd_EP					;  . .
		dec YL						;  
		cpi temp3,0x19				;     ,
		breq PC+3					;
		ldi temp3,0xBC				;    
		rcall Wr_EP					;    
		rcall Rd_EP					;   EEPROM
		mov temp,temp3				;
		rcall lcd_kntr       		;    
in_dspl:	;      
		rcall lcd_clr				; LCD
		rcall light					;  
		POZ_LCD 0,0					;0- , 0- 
		LOAD_ADDR Z,Messg1*2		;.  Z  
		rcall Str_LCD				;  
		POZ_LCD 0,3					;0- , 3- 
		LOAD_ADDR Z,Messg3*2		;.  Z  
		rcall Str_LCD				;  LCD 
		
		;    ""
		POZ_LCD 10,2			;10- , 2- 
		LOAD_ADDR Z,Messg4*2	;.  Z . . ""
		rcall Str_LCD			;   
		
		rcall IIC_init				;  IIC
		;  RDA5807
		;   
		LOAD_ADDR Y,Vol_EE			;.  Y .. 
		rcall Rd_EP					;   EEPROM
		cpi temp3,17				;   , -
		brlo PC+2					;  .
		ldi temp3,7					; .  = 7
		andi temp3,0x0F				;  
		sts volume,temp3			;    
		rcall Wr_EP					;    
		rcall set_vol				; 
		rcall type_vol				;    LCD
		;   
		LOAD_ADDR Y,Fst_EE			;.  Y .. 
		rcall Rd_EP					;    EEPROM
		mov freq,temp3				;
		cpi freq,210				;    >210,
		brlo PC+2					; .. 210+870=1080,
		ldi freq,210				;  freq =210
		
		DELAY 2					;
		;    
		ldi YL,LOW(R_cnfg)			;.  Y .. . -
		clr YH						;
		rcall Rd_EP					; .   EEPROM
		cpi temp3,0xFF				;   ,-
		breq PC+3					;
		cpi temp3,0xC0				;    
		brpl rg_st					;
		ldi temp3,0b11010000		;(02H): ., DMUTE=1,,,
									; SEEKUP=0, SEEK=0 ( )
		rcall Wr_EP					;   . -  
		
rg_st:	mov R5,temp3				;
		sbrs temp3,4				; .   , -
		rjmp Nstrka					;    
		POZ_LCD 3,0					;3- , 0- 
		ldi temp,'B'				;   
		rcall lcd_put_char			;  .   LCD
	
Nstrka:		;    
		rcall rekog					;  ( .  R9)
		rcall Prnt_F				;   
		DELAY 10					;
		rcall ch_st					;-  . RDA5807 (- freq)
		DELAY 10					;
		; 
		clr r2						;  
		clr s_tm					;   . 
		clr r8						;   
		clr r10						;  .  
		clr R13						;   
		clr freq					;  
		clr temp3					;  R19
		rcall U_bat					;   
				; 
		rcall DS_Start				;  
		rcall out_1Hz				;   RTC  1 
		;    
		rcall DS_get_time			;      RTC
		clr temp					;
		sts prv_T,temp				;   
		sts prv_T+1,temp			;
		sts prv_T+2,temp			;
		rcall Cur_T					;    
		ldi temp,(1<<INT0)			;    INT_0
		out GICR,temp				;
		;   
		ldi temp,10					;  
		mov R14,temp				;   Ubat  
		rcall DS_sensor				;    DS18B20
		rcall bcd_convert			;     LCD
		rcall Prnt_Temp				;   LCD
		nop
		
;=====================   ==========================================
main: 			; 
		in temp,PINB				;  
		sbrs temp,7					;   Pwr,  
		rcall pwr_off				;  
		in temp,PIND				; 
		com temp					; 
		andi temp,0b00011011		;  
		push temp					;
		lsr temp					; 
		andi temp,0b00001100		; . 
		mov R1,temp					; . 
		pop temp					;
		andi temp,0b00000011		; . 
		or R1,temp					;  
		;   ()
		DELAY 1						; 32  
		tst R2						;   ,
		breq main					;   
		rcall light					;  
		; 
reg_V:	sbrc R2,0					;   V+
		rcall vol_up				;    
		sbrc R2,1					;   V-
		rcall vol_dw				;    
		sbrc R2,0					;   V+
		rjmp m_loop					;
		sbrc R2,1					;   V-
		rjmp m_loop					;
		
		;   
cnt_tm:	cp R1,R2					;  , 
		breq PC+2					;    -
		rjmp long					;
		inc R10						;    
		rjmp main					;
		
		;   
long:	mov temp,R10				;  
		cpi temp,45					;   -
		brmi lng_ts					;   ,  -
		rcall mode_s				;   .   R8
lng_ts:	tst R8						;  
		breq hand					;  0 -    
		
ch_ch:	;  
		sbrc R8,2					;   CH+,
		rjmp menu					;    
		sbrc R8,3					;   CH-
		rjmp avto					;    
	 	rjmp hand					;, -    
		
	;	rjmp m_loop					;    
		
		;
avto:	sbrc R2,2					;   CH+
		rcall freq_Up				;    
		sbrc R2,3					;   CH-
		rcall freq_Down				;    
		rjmp m_loop					;
		;  
hand:	sbrc R2,2					;   CH+
		rcall St_Up					;     
		sbrc R2,3					;   CH-
		rcall St_Down				;     
		
m_loop: clr R2						;  
		clr R10						;  .  
		rjmp main					;   
		
 ;===========================================================================
;	    
;---------------------------------------------------------------------------
 Mes_menu1:	.DB	"          ",0,0 
 Mes_menu2:	.DB	"V+       ",0,0 
 Mes_menu3:	.DB	"V-        ",0,0 
 Mes_menu4:	.DB	"+   ",0,0 
 Mes_menu5:	.DB	"CH-      ",0,0 
;---------------------------------------------------------------------------
 menu:	
 		ldi temp,(0<<INT0)			;    INT_0
		out GICR,temp				;
 		ldi temp3,0					;  1  2
		out TCCR2,temp3				; 1-    
		out TCCR1B,temp				; 2-    
		;  
		LOAD_ADDR Z,Mes_menu1*2		;.  Z  
		POZ_LCD 0,0					;0- , 1- 
		rcall Str_LCD				;  "    "
 		LOAD_ADDR Z,Messg3*2		;.  Z  
		rcall Str_LCD				;  "_________"
		LOAD_ADDR Z,Mes_menu2*2		;.  Z  
 		rcall Str_LCD				;  "V+        "
 		LOAD_ADDR Z,Mes_menu3*2		;.  Z  
 		rcall Str_LCD				;  "V-        "
 		LOAD_ADDR Z,Mes_menu4*2		;.  Z  
 		rcall Str_LCD				;  "+   "
 		LOAD_ADDR Z,Mes_menu5*2		;.  Z  
 		rcall Str_LCD				;  "CH-      "
 		DELAY 15					; 485  
 		
 but_m:		; 
		sbis PIND,PD0				;   V+
 		rjmp set_clock				;    
		sbis PIND,PD1				;   V-
		rjmp setings				;    
		sbis PIND,PD3				;   CH+
		rjmp kntrst					;   . 
		sbis PIND,PD4				;   CH-
		rjmp ql_menu				;    
		DELAY 1						; 32  
		rjmp but_m					;  
 		
 ql_menu:		;   
 		clr R8						;   
 		ldi temp,0b00000101			;
		out TCCR1B,temp				;  1   1/1024
 		sei							; 
 		rjmp in_dspl				;  . 
 		
 ;===========================================================================
;		  
;----------------------------------------------------------------------------
  	Mes_clk1:	.DB " .  ",0,0
  	Mes_clk2:	.DB " .  ",0,0
 	Mes_clk3:	.DB	"V+/V- .  ",0,0
 	Mes_clk4:	.DB	"CH+ /. ",0,0
 	Mes_clk5:	.DB	"CH-   ",0,0
;---------------------------------------------------------------------------
 set_clock: 
			rcall lcd_clr				; 
 			;  
			POZ_LCD 0,0					;1- , 0- 
			LOAD_ADDR Z,Mes_clk1*2		;.  Z  
			rcall Str_LCD				; . " .  "
			LOAD_ADDR Z,Messg3*2		;.  Z  
			rcall Str_LCD				;  "_________"
			rcall clr_line				; 
			
			POZ_LCD 0,3					;0- , 3- 
			LOAD_ADDR Z,Mes_clk3*2		;.  Z  
			rcall Str_LCD				; . "V+/V- .  "
			LOAD_ADDR Z,Mes_clk4*2		;.  Z  
			rcall Str_LCD				; . "CH+ /   "
			LOAD_ADDR Z,Mes_clk5*2		;.  Z  
			rcall Str_LCD				; . "CH-   "
			DELAY 10					; 320 
 			
 			;  
 			rcall DS_get_time			;      RTC
 			rcall time_ind				;   
 			
 clk_t:		; 
			sbis PIND,PD0				;   V+
	 		rcall time_up				;   
	 		sbis PIND,PD1				;   V-
	 		rcall time_dw				;   
	 		sbis PIND,PD3				;   V-
	 		rcall H_min					;   . /
			sbis PIND,PD4				;   CH-
			rjmp set_out				;     
			DELAY 1						; 32 
			rjmp clk_t					;  
  			
 set_out:	;   
			rcall DS_Set_time			; .  RTC
 			clr R8						;   
 			clr s_tm					;   . 
 			ldi temp,(1<<INT0)			;    INT_0
			out GICR,temp				;
 			rjmp ql_menu				;    
 			
;===========================================================================
;		  
;---------------------------------------------------------------------------
 	Mes_nstr1:	.DB	"     ",0,0
 	Mes_nstr2:	.DB	"V+ . ",0,0
 	Mes_nstr3:	.DB	"V- /",0,0
;---------------------------------------------------------------------------
setings:
		rcall lcd_clr				; 
		;  
		POZ_LCD 0,0					;1- , 0- 
		LOAD_ADDR Z,Mes_nstr1*2		;.  Z  
		rcall Str_LCD				; . "
		POZ_LCD 0,1					;0- , 1- 
		LOAD_ADDR Z,Messg3*2		;.  Z  
		rcall Str_LCD				;  "__________"
		POZ_LCD 0,2					;0- , 2- 
		LOAD_ADDR Z,Mes_nstr2*2		;.  Z  
		rcall Str_LCD				; . "V+ ."
		POZ_LCD 0,3					;0- , 3- 
		LOAD_ADDR Z,Mes_nstr3*2		;.  Z  
		rcall Str_LCD				; . "V- /"
		POZ_LCD 0,4					;0- , 4- 
		LOAD_ADDR Z,Mes_menu5*2		;.  Z  
		rcall Str_LCD				; . "CH-  "
		DELAY 10					; 320  
				;  
		sbrs R5,4					; .   , -
		rjmp ms_read				;    
		POZ_LCD 11,0				;11- , 0- 
		ldi temp,'B'				;   
		rcall lcd_put_char			;  .   LCD
ms_read:		;  /
		POZ_LCD 13,0				;13- , 0- 
		sbrs R5,5					; . 
		rjmp PC+3					;
		ldi temp,'M'				;   M
		rjmp PC+2					;
		ldi temp,'S'				;   S
		rcall lcd_put_char			;  M/S  LCD
		
debug_t:		; 
		sbis PIND,PD0				;   V-
 		rcall bass					;   . BASS
 		sbis PIND,PD1				;   V+
 		rcall mono_st				;   . MONO/STEREO
		sbis PIND,PD4				;   CH-
		rjmp ql_menu				;   
		DELAY 1						; 32  
		rjmp debug_t				;  
		
;===========================================================================
;		/  
;---------------------------------------------------------------------------
 bass:	DELAY 10					; 320 
 		POZ_LCD 11,0				;3- , 0- 
 		ldi YL,LOW(R_cnfg)			;.  Y .. . -
		clr YH						;
		rcall Rd_EP					; .   EEPROM
 		
 		sbrc temp3,4				; .   , -
 		rjmp no_bas					;
 		ori temp3,0b00010000		;   . 
 		ldi temp,'B'				;   
		rcall lcd_put_char			;  .   LCD
		rjmp sohr					;
 		
no_bas:	sbrs temp3,4				; .   , -
		rjmp sohr					;
 		andi temp3,0b11101111		;   . 
 		ldi temp,' '				;  
		rcall lcd_put_char			;  .   LCD
 		
 sohr:	
 		rcall Wr_EP					;   . -  
		mov R5,temp3				;
		LOAD_ADDR Y,Fst_EE			;.  Y .. 
		rcall Rd_EP					;    EEPROM
		mov freq,temp3				;
 		rcall Config_RDA5807		;  
 		
 		ret
		
;===========================================================================
;		 MONO/STEREO
;---------------------------------------------------------------------------
mono_st:	
		DELAY 10					; 320 
		POZ_LCD 13,0				;13- , 0- 
		ldi YL,LOW(R_cnfg)			;.  Y .. . -
		clr YH						;
		rcall Rd_EP					; .   EEPROM
 		
 		sbrc temp3,5				; MONO  , -
 		rjmp stereo					;
 		ori temp3,0b00100000		;   MONO
 		rcall Mono					; MONO
 		rjmp sohran					;
 		
stereo:	sbrs temp3,5				; MONO  , -
		rjmp sohran					;
 		andi temp3,0b11011111		;   MONO
 		rcall Ster					;  STRERO
 		
 sohran:
 		rjmp sohr					;
 		
;===========================================================================
;		   Nokia 5110
;.     0  0x7F (  080  0xFF).
;  (  128  255  127 )
;---------------------------------------------------------------------------
 	Mes_kntr1:	.DB	" ",0,0 
 	Mes_kntr2:	.DB	"V+      ",0,0 
 	Mes_kntr3:	.DB	"V-      ",0,0 
;---------------------------------------------------------------------------
kntrst:	rcall lcd_clr				; 
		;  
		POZ_LCD 0,0					;0- , 2- 
		LOAD_ADDR Z,Mes_kntr1*2		;.  Z  
		rcall Str_LCD				; . " "
		LOAD_ADDR Z,Messg3*2		;.  Z  
		rcall Str_LCD				; 
		LOAD_ADDR Z,Mes_kntr2*2		;.  Z  
		rcall Str_LCD				; . "V+      "
		LOAD_ADDR Z,Mes_kntr3*2		;.  Z  
		rcall Str_LCD				; . "V-      "
		LOAD_ADDR Z,Mes_menu5*2		;.  Z  
		rcall Str_LCD				; . "-      "
		DELAY 10					; 320  
		
		LOAD_ADDR Y,kontrast		;.  Y .. 
		rcall Rd_EP					;   EEPROM
		rcall prnt_kntr				;   
		
kntr_mn:		; 
		sbis PIND,PD0				;   V+
 		rcall kntr_up				;  
		sbis PIND,PD1				;   V-
		rcall kntr_dw				;  
		sbis PIND,PD4				;   CH-
		rjmp ex_kntr				;   
		DELAY 1						; 32 
		rjmp kntr_mn				;  
ex_kntr:
		LOAD_ADDR Y,kontrast		;.  Y .. 
		rcall Wr_EP					;   
		inc YL						;
		ldi temp3,0x19				;  
		rcall Wr_EP					;   
		
		rjmp ql_menu				;
		
;===========================================================================
;		 
;---------------------------------------------------------------------------
 kntr_up:
		cpi temp3,0x80				;  . .  0x80
		brsh PC+2					;
		ldi temp3,0x80				; , -   0x80
		cpi temp3,0xDC				;  . .  0xDC
		brmi PC+2					;
		ldi temp3,0xDC				; , -   0xDC
		inc temp3					; 
		rcall lcd_kntr       		;    
		rcall prnt_kntr				;   
		DELAY 8						; 320 
		ret

;===========================================================================
;		 
;---------------------------------------------------------------------------
 kntr_dw:
		
		cpi temp3,0xAA				;  . .  0xAA
		brsh PC+2					;
		ldi temp3,0xAA				; , -   0xAA
		cpi temp3,0xDC				;  . .  0xDC
		brmi PC+2					;
		ldi temp3,0xDC				; , -   0xDC
		
		dec temp3					; 
		rcall lcd_kntr       		;    
		rcall prnt_kntr				;   
		DELAY 8						; 320 
		ret
;===========================================================================
;	       
;---------------------------------------------------------------------------
 prnt_kntr:	push temp3
 			mov temp,temp3				;  
			ldi R17,0					;
			rcall bin16_dec5			;  10- 
			ldi YL,LOW(decnum+2)		;.  X . .   
			clr YH						;
			POZ_LCD 5,5					;5- ,5- 
			
			ld temp,Y					; .  
			subi temp, -0x30			;   ASCII-
			rcall lcd_put_char			; .    LCD
			ld temp,-Y					; .  
			subi temp, -0x30			;   ASCII-
			rcall lcd_put_char			; .   LCD
			ld temp,-Y					; .  
			subi temp, -0x30			;   ASCII-
			rcall lcd_put_char			; .    LCD
			
			pop temp3
			ret
			
;===========================================================================
;		   
;---------------------------------------------------------------------------
 lcd_kntr:	ldi temp,0x21				;
			rcall lcd_cmd       		;    
			mov temp,temp3				;
			rcall lcd_cmd       		;    
			ldi temp,0x20				;
			rcall lcd_cmd       		;    
			ret
			
;============================================================================
;*******************  ***************************************************
;============================================================================
;		    
;----------------------------------------------------------------------------
 time_ind:
 		POZ_LCD 2,2				;2- , 2- 
 		inc fnt_d				;  
 		lds R20,T_clk+2			;    
 		mov temp,R20			;
 		swap temp				; 
		andi temp,0x0F			; . 
		subi temp, -0x30		;   ASCII-
		rcall lcd_put_char		;    LCD
		
		mov temp,R20			;
		andi temp,0x0F			; . 
 		subi temp, -0x30		;   ASCII-
		rcall lcd_put_char		;    LCD
 		
 		ldi temp,':'			;  
 		rcall lcd_put_char		;   LCD
 		
 		lds R20,T_clk+1			;    
 		mov temp,R20			;
 		swap temp				; 
		andi temp,0x0F			; . 
		subi temp, -0x30		;   ASCII-
		rcall lcd_put_char		;    LCD
		
		mov temp,R20			;
		andi temp,0x0F			; . 
 		subi temp, -0x30		;   ASCII-
		rcall lcd_put_char		;    LCD
 		clr fnt_d				;  
 		DELAY 5					;
 		
 		ret
		
;==============================================================================
;		 
;----------------------------------------------------------------------------

H_up:	; 
		lds temp,T_clk+2	;   . 
		cpi temp,0x23		;  
		brge ed_pl			; ,  
		andi temp,0xF0		; .  
		mov R11,temp		;  R11
		lds temp,T_clk+2	;   . 
		andi temp,0x0F		; .  
		inc temp			; .  
		cpi temp,10			;  10, -
		brlo du_i			;   
		mov temp,R11		;
		subi temp,(-0x10)	; . 
		mov R11,temp		;
du_i:	or temp,R11			;  
		sts T_clk+2,temp	;  
ed_pl:	clr temp			;
		sts prv_T+2,temp	;  
		rcall time_ind		;   
		
		ret
		
;----------------------------------------------------------------------------
H_dw:	; 
		lds temp,T_clk+2	;   . 
		tst temp			;  
		breq ed_mi			; ,  
		andi temp,0xF0		; .  
		mov R11,temp		;  R11
		lds temp,T_clk+2	;   . 
		andi temp,0x0F		; .  
		dec temp			; .  
		cpi temp,0			; 0, -
		brpl dw_i			;   
		mov temp,R11		;
		subi temp,0x10		; . 
		mov R11,temp		;
		ldi temp,9			;9  . 
dw_i:	or temp,R11			;  
		sts T_clk+2,temp	;  
ed_mi:	clr temp			;
		sts prv_T+2,temp	;  
		rcall time_ind		;   
		
		ret
		
;----------------------------------------------------------------------------
 time_up:	tst s_tm					;
 			brne Min_up					;
 			breq H_up					;
 			
 time_dw:	tst s_tm					;
 			brne Min_dw					;
 			breq H_dw					;

;----------------------------------------------------------------------------
Min_up:	; 
		lds temp,T_clk+1	;   . 
		cpi temp,0x59		;  
		brge md_pl			; ,  
		andi temp,0xF0		; .  
		mov R11,temp		;  R11
		lds temp,T_clk+1	;   . 
		andi temp,0x0F		; .  
		inc temp			; .  
		cpi temp,10			;  10, -
		brlo mu_i			;   
		mov temp,R11		;
		subi temp,(-0x10)	; . 
		mov R11,temp		;
mu_i:	or temp,R11			;  
		sts T_clk+1,temp	;  
md_pl:	clr temp			;
		sts prv_T+1,temp	;  
		rcall time_ind		;   
		
		ret
		
;----------------------------------------------------------------------------
Min_dw:	; 
		lds temp,T_clk+1	;   . 
		tst temp			;  
		breq med_mi			; ,  
		andi temp,0xF0		; .  
		mov R11,temp		;  R11
		lds temp,T_clk+1	;   . 
		andi temp,0x0F		; .  
		dec temp			; .  
		cpi temp,0			; 0, -
		brpl mdw_i			;   
		mov temp,R11		;
		subi temp,0x10		; . 
		mov R11,temp		;
		ldi temp,9			;9  . 
mdw_i:	or temp,R11			;  
		sts T_clk+1,temp	;  
med_mi:	clr temp			;
		sts prv_T+1,temp	;  
		rcall time_ind		;   
		
		ret
		
;==============================================================================
;		  /
;----------------------------------------------------------------------------
 H_min:	
 		POZ_LCD 0,0				;0- , 5- 
 		tst s_tm				;
 		breq minuta				;
 		
 		LOAD_ADDR Z,Mes_clk1*2	;.  Z . .
 		rcall Str_LCD			;" .  "
 		clr s_tm				;
 		DELAY 10				;
 		ret
 		
 minuta:  
 		LOAD_ADDR Z,Mes_clk2*2	;.  Z . .
 		rcall Str_LCD			;" . 
 		inc s_tm				;
 		DELAY 10				;
 		ret
 		
;==============================================================================
;		     
Cur_T:	cli
		push temp
		push temp1
		push temp2
		push ZL
		push ZH
		push R20
		lds XL,poz_num				; 
		lds XH,str_num				;   LCD
			;  
		lds temp1,prv_T+1			;    
		lds temp2,prv_T+2			;
		lds R20,T_clk+2				;    
		tst R20						;  00,  -
		breq ind_H					;    
		cp R20,temp2				;   , -
		breq tst_min				;   
		
ind_H:		;  LCD 
		ldi temp,7					;7- 
		mov R6,temp					;  
		rcall lcd_X_1				;    
		ldi temp,3					; 3- 
		rcall lcd_Y					;  3- 
		rcall Dig_clok				;  LCD 
		
	;	ldi temp,0x0B				;  
	;	rcall Dig_Clk				;  LCD 
		
tst_min:	;  
		lds R20,T_clk+1				;    
		tst R20						;  00,  -
		breq ind_M					;    
		cp R20,temp1				;   , -
		breq tim_out				;   
		
ind_M:		;  LCD 
		ldi temp,13					;13- 
		mov R6,temp					;  
		rcall lcd_X_1				;    
		ldi R16,3					; 3- 
		rcall lcd_Y					;  3- 
		rcall Dig_clok				;  LCD 
tim_out:
		sts poz_num,XL				; 
		sts str_num,XH				;   LCD
		pop R20
		pop ZH
		pop ZL
		pop temp2
		pop temp1
		pop temp
		sei
		ret
		
;===========================================================================
Dig_clok:	;  LCD 
		mov temp,R20			;
		swap temp				; 
		andi temp,0x0F			; . 
		rcall Dig_Clk			;  LCD . 
		
		mov temp,R20			;
		andi temp,0x0F			; . 
		rcall Dig_Clk			;  LCD . 
		
		ret
;===========================================================================
;	/     1   
;---------------------------------------------------------------------------
INT_0:
		push temp					;   R16
    	in temp,SREG      			;
   		push temp         			;   SREG
		push temp1					;   
		push R0						;
		push R1						;
		push R6						;
			;   
		lds temp,T_clk				; 
		sts prv_T,temp				;   
		lds temp,T_clk+1			; 
		sts (prv_T+1),temp			;   
		lds temp,T_clk+2			; 
		sts (prv_T+2),temp			;   
		
		dec R14						;   
		tst R14						;    ,
		brne PC+2					;  
		rcall Prnt_U_T				;  . .  Ubat
		
		; 
		lds XL,poz_num				; 
		lds XH,str_num				;   LCD
		
		ldi temp,11					;11- 
		mov R6,temp					;  
		rcall lcd_X_1				;    
		ldi temp,3					; 3- 
		rcall lcd_Y					;  3- 
		lds temp,T_clk				; 
		sbrc temp,0					;   , -
		rjmp dot_clr				;  
		;  LCD 
		ldi temp,0x0B				;  
		rcall Dig_Clk				;  LCD 
		rjmp poz_clr				;
dot_clr:	;   
		ldi temp,0x0A				;  
		rcall Dig_Clk				;  LCD 
poz_clr:
		sts poz_num,XL				; 
		sts str_num,XH				;   LCD
		
sek_pl:		; 1 
		lds temp,T_clk				;    
		rcall BCD_HEX				;  BCD  HEX
		inc temp					;   1
		cpi temp,60					;  60 ., 
		brge inc_min				;   
		rcall HEX_BCD				;  HEX  BCD
		sts T_clk,temp				;   
		rjmp wyh_int				;   
inc_min:	; 1 
		clr temp					; 
		sts T_clk,temp				;    00 
		
		lds temp,T_clk+1			;    
		rcall BCD_HEX				;  BCD  HEX
		inc temp					;   1
		cpi temp,60					;  60 ., 
		brge inc_h					;   
		rcall HEX_BCD				;  HEX  BCD
		sts T_clk+1,temp			;   
		rjmp end_int				;   
inc_h:		; 1 
		clr temp
		sts T_clk+1,temp			;    00 
		
		lds temp,T_clk+2			;    
		rcall BCD_HEX				;  BCD  HEX
		inc temp					;   1
		cpi temp,24					;  24 , 
		brge clr_Tm					;    
		rcall HEX_BCD				;  HEX  BCD
		sts T_clk+2,temp			;   
		rjmp end_int				;
clr_Tm:		;    24:00
		clr temp					;
		sts T_clk,temp				;    00 
		sts T_clk+1,temp			;    00 
		sts T_clk+2,temp			;    00 
end_int:
		rcall Cur_T					;    
wyh_int:
		pop R6						;    
		pop R1						;
		pop R0						;
		pop temp1					;
		pop temp					;   SREG
    	out SREG,temp     			;
    	pop temp          			;   R16
		
		reti
		
;===========================================================================
;	       
;---------------------------------------------------------------------------
 Prnt_U_T: 
 		push temp3         		;C   temp3
		rcall U_bat         	;   
		
		sbis PIND,5				;  ,
		breq end_T2				;   
		rcall DS_sensor			;    DS18B20
		push temp3         		;C   
		lds temp,Gradus			;  
		cp temp,temp3			;   ,
		breq end_T1				;     LCD
		rcall bcd_convert		;     LCD
		rcall Prnt_Temp			;   LCD
end_T1:	pop temp3				;   
		
end_T2:	sts Gradus,temp3		;   
		pop temp3				;   temp3
		ldi temp,10				;   
		mov R14,temp			;   Ubat  
		ret
		
;************************  ********************************************
;===========================================================================
mode_s:		;   /
		clr R10						;  .  
		tst R8						;   
		brne rev					;
		mov R8,R2					;   
		rjmp rev_end				;
rev:	clr R8						;    
		
rev_end:clr temp					; temp    
 		ret

;===========================================================================
 St_Up:			;     FLASH
 	;	cli
 		LOAD_ADDR Z,freq_st*2		;.  Z . ..  
		;  
		inc R9						;  
		mov temp,R9
 		cpi temp,Nst				;    > Nst
 		brlo st_u					;
 		clr R9						;     
 		rjmp st_set					;
 		
;---------------------------------------------------------------------------
St_Down:	;     FLASH
	;	cli
		LOAD_ADDR Z,freq_st*2		;.  Z . ..  
		;  
 		dec R9						;   ,
 		tst R9						;   > 0,  
 		brpl st_u					;   ,  -
 		ldi temp,(Nst-1)			;     
 		mov R9,temp					;
 		;     . 
 st_u:	breq st_set					;  =0,   
 		push R9						;
		adiw Z,16					;    . 
		dec R9						;
		brne PC-2					;
		pop R9						;
		
st_set:	lpm freq,Z					;   FLASH
		adiw Z,1					;    
		rcall Print					;    
		rcall Prnt_F				;   
		;   
ch_st:		;		push freq					;
		rcall Mono					; ""
	;	ldi temp,0b11010010			;(02H) ., DMUTE=1,,,
									 ;SEEKUP=1, SEEK=0 ( )
		ldi YL,LOW(R_cnfg)			;.  Y .. . -
		clr YH						;
		rcall Rd_EP					; .   EEPROM
		
		mov r5,temp3					;
		rcall Config_RDA5807		;  /
		rcall stepr_FV				; F  V  
		DELAY 20					;
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		
		sbrc R5,5					;  MONO
		rjmp urov					;   S
		lds r17,seek_fm				;  . 
		sbrc r17,2					; , -
		rcall Ster					; ""
urov:	rcall type_lev				;  
		rcall type_vol				;    LCD
		
		clr temp					; temp    
	;	sei
		ret
		
;===========================================================================
;		/  
;---------------------------------------------------------------------------
rekog:
		cli							;
		clr R9						;  
		LOAD_ADDR Z,freq_st*2		;.  Z . ..  
rd_fr:	lpm temp,Z					;   FLASH
		cp temp,freq				;  ,   ,  -
		breq na_ind					;    
		inc R9						;  
		mov temp,R9					;  , 
		cpi temp,Nst				;    , -
		brsh fall					;  . ". "
		adiw Z,16					;   
		rjmp rd_fr					;  
		
fall:	LOAD_ADDR Z,Messg2*2		;  . ". "
		rjmp PC+2					;  
		
na_ind:	adiw Z,1					;    
			;    
Print:	POZ_LCD 0,5					;0- , 5- 
		rcall Str_LCD				;    
		sei
		ret
		
;===========================================================================
freq_Up: 	;   "+"   
	;	cli							; 
		inc freq					; 
		cpi freq,210				;    >210
		brlo PC+2					; 210+870=1080
		clr freq					;  freq =0
			;  ""
		POZ_LCD 0,5					;0- , 5- 
		LOAD_ADDR Z,Messg5*2		;.  Z  
		rcall Str_LCD				; .  LCD
		rcall Mono					; ""
		
			;     
		ldi YL,LOW(R_cnfg)			;.  Y .. . -
		clr YH						;
		rcall Rd_EP					; .   EEPROM
		ori temp3,0b00000011		; SEEKUP=1, SEEK=1 ( )
		mov R5,temp3				; - 
r_con:	rcall Config_RDA5807		; 
		
nov_p:	DELAY 20					;
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds r17,seek_fm				;  . 
		sbrs r17,6					;STC=1?    , -
		rjmp nov_p					;  . 
		
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds freq,read_fm			;  
		lds r17,seek_fm				;  . 
		sbrs r17,5					;SF=1?   , -
		rjmp st_tn					;  
		cpi freq,210				;    >210,
		brlo PC+2					; .. 210+870=1080,
		clr freq					;  freq =0
		rjmp r_con					;  
		
		rjmp st_tn					;  

;===========================================================================
freq_Down:		;   "-"   
;		cli
		dec freq					; 
			;  ""
		POZ_LCD 0,5					;0- , 5- 
		LOAD_ADDR Z,Messg5*2		;.  Z  
		rcall Str_LCD				; .  LCD
		rcall Mono					; ""
			;     
		ldi YL,LOW(R_cnfg)			;.  Y .. . -
		clr YH						;
		rcall Rd_EP					; .   EEPROM
		andi temp3,0b11111101		; SEEKUP=0, SEEK=1 ( )
		ori temp3,0b00000001		;
		
		mov R5,temp3					; - 
rm_con:	rcall Config_RDA5807		; 
		
nov_m:	DELAY 20					;
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds r17,seek_fm				;  . 
		sbrs r17,6					;STC=1?    , -
		rjmp nov_m					;  . 
		
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds freq,read_fm			;  
		lds r17,seek_fm				;  . 
		sbrs r17,5					;SF=1?   , -
		rjmp st_tn					;  
		tst freq					;    =0
		brne PC+2					; 210+870=1080
		ldi freq,210				;  freq =210
		rjmp rm_con					;  
		
		;     
st_tn:	ldi YL,LOW(R_cnfg)			;.  Y .. . -
		clr YH						;
		rcall Rd_EP					; .   EEPROM
		andi temp3,0b11111100		; SEEKUP=0, SEEK=0 ( )
		
		mov R5,temp3				; - 
		rcall Config_RDA5807		; 
		rcall stepr_FV				; F  V  
		
		sbrc R5,5					;  MONO
		rjmp urovn					;   S
		sbrc r17,2					; , -
		rcall Ster					; ""
urovn:	rcall type_lev				;  
		rcall type_vol				;    LCD
		rcall rekog					; 
		rcall Prnt_F				;   
		
		clr temp					; temp    
	;	sei							; 
 		ret
 		
;===========================================================================
;			 /   RDA5807M
;---------------------------------------------------------------------------
Read_RDA5807:
		cli
		rcall IIC_Start			;  
		ldi temp,0b00100001		;   021
		rcall IIC_Send			;  
		
		rcall IIC_Recieve		;(0)   
		sts seek_fm,temp		;    . 
		
		rcall IIC_Recieve		;(0L)   
		sts read_fm,temp		;     
		mov freq,temp			;     
		
		rcall IIC_Recieve_lst	;(0B)   
		lsr temp				;   
		sts level,temp			;      
		
		rcall IIC_Stop			;  
		sei
		
		ret
		
;===========================================================================
; 			    RDA5807
;---------------------------------------------------------------------------
Config_RDA5807: 
		cli
		push R16          	;   R16
    	in R16,SREG      	;
   		push R16         	;   SREG
		;     
; .F_3H . 8  .  .F_3L .2  . &  ..
		mov F_3H,freq				;
		clc							;  
		clr F_3L					;
		lsr F_3H					;
		ror F_3L					;
		lsr F_3H					;
		ror F_3L					;
		ori F_3L,0x10				;   
		;     RDA5807
		rcall iic_start				; 
		ldi temp,0x20				;    RDA5807
		rcall IIC_Send				;  
		
		mov temp,r5					;   -
		rcall IIC_Send				;(02) = r5
		ldi temp,0b10000101			;(02L):  SKMODE=1 Fclk=32.768kHz,
		rcall IIC_Send				; RDS_EN=0,NEW_METHOD=1, Power Up
		
		mov temp,F_3H				;(03H) . 8  
		rcall IIC_Send				;
		mov temp,F_3L				;(03L) .2  . &  ..
		rcall IIC_Send				;	87108 MHz	 100 
		
		ldi temp,0b00001000			;(04H) De-emphasis  1 = 50 s
		rcall IIC_Send				;
		ldi temp,0					;(04L)
		rcall IIC_Send				;
		
		ldi temp,0b10001000 		;(05H)- .,  . 
		rcall IIC_Send				;
		lds temp,volume				;(05L)     
		tst temp					;  ,  -
		brpl PC+2					;
		ldi temp,0					;    
		sts volume,temp				;  
		ori temp,0b11000000			; .   
		rcall IIC_Send				;  
		rcall iic_stop 				; 
		
		pop R16          		;   SREG
    	out SREG,R16     		;
    	pop R16          		;   R16
		sei
		ret

;========================================================================
;		      
;-------------------------------------------------------------------------
stepr_FV:
		cli
		LOAD_ADDR Y,Fst_EE			;.  Y . 
		mov temp3,freq				;
		rcall Wr_EP					;    
		LOAD_ADDR Y,Vol_EE			;.  Y .. 
		lds temp3,volume			;    
		rcall Wr_EP					;   
		sei
		ret
		
; ========================================================================
		; 
vol_up:	cli
		clr R1				;
		lds temp,volume		;    
		cpi temp,15			;  
		breq vol_st			; ,  
		; 
		tst temp			;
		brpl PC+3			;   , 
		clr temp			;   ,
		rjmp PC+2			;   
		inc temp			;
		sts volume,temp		;  
vol_st:	rcall wr_vol		;   RDA5807m
		DELAY 10			; 320 
		clr temp			; temp    
		sei
		ret
;========================================================================
		; 
vol_dw:	cli
		clr R1				;
		lds temp,volume		;    
		tst temp			;  .  < 0, 
		brmi PC+2			;   ,  -
		dec temp			;   
		sts volume,temp		;   
		tst temp			;   
		brpl vol_mi			;  .  < 0, 
		rcall mute			;    
		rcall type_vol		;   
		rjmp PC+2			;
		
vol_mi:	rcall wr_vol		;   RDA5807m
		DELAY 10			; 320 
		clr temp			; temp    
		sei
		ret
		
;========================================================================
; /    RDA5807M     0x22
;-------------------------------------------------------------------------
mute:	cli							; 
		ldi YL,LOW(R_cnfg)			;.  Y .. . -
		clr YH						;
		rcall Rd_EP					; .   EEPROM
		andi temp3,0b10111111		; DMUTE=0
		mov R5,temp3				; - 
		;
		rcall iic_start				;  ""
		ldi temp,0x22				;  
		rcall IIC_Send				;  
		
		ldi temp,0x02				;  (02H)  
		rcall IIC_Send				;  
		
		mov temp,R5					;   -
		rcall IIC_Send				;(02) = R5
		ldi temp,0b10000101			;(02L):  SKMODE=1 Fclk=32.768kHz,
		rcall IIC_Send				; RDS_EN=0,NEW_METHOD=1, Power Up
		
		rcall iic_stop 				;  ""
		sei							; 
		
		ret
; ========================================================================
; /    RDA5807M     0x22
;-------------------------------------------------------------------------
wr_vol:	;     RDA5807
		cli							; 
		ldi YL,LOW(R_cnfg)			;.  Y .. . -
		clr YH						;
		rcall Rd_EP					; .   EEPROM
		ori temp3,0b01000000		; DMUTE=1
		mov R5,temp3				; - 
		; 
		rcall iic_start				;  ""
		ldi temp,0x22				;  
		rcall IIC_Send				;  
		
		ldi temp,0x02				;  (02H)  
		rcall IIC_Send				;  
			
		mov temp,R5					;   -
		rcall IIC_Send				;(02) = R5
		ldi temp,0b10000101			;(02L):  SKMODE=1 Fclk=32.768kHz,
		rcall IIC_Send				; RDS_EN=0,NEW_METHOD=1, Power Up
		
		rcall iic_stop 				;  ""
 set_vol:		;    
		rcall iic_start				;  ""
		ldi temp,0x22				;  
		rcall IIC_Send				;  
		
		ldi temp,0x05				;  (05H)  
		rcall IIC_Send				;
		
		ldi temp,0b10001000  		;(05H) - .,  . 
		rcall IIC_Send				;
		lds temp,volume				;(05L)     
		ori temp,0b10000000			;
		rcall IIC_Send				;   RDA5807m
		
		rcall iic_stop 				;  ""
		rcall type_vol				;   
		sei
		
		ret
;===========================================================================
;		/     LCD 
;---------------------------------------------------------------------------
type_vol:	;    LCD
		cli
		POZ_LCD 6,0					;6- , 0- 
		
		lds temp,volume				;    
		tst temp					;  ,  -
		brpl PC+3					;
		clr temp					;      00,
		rjmp prbr					; , -  
		inc temp					;  1 
		
  prbr:		;   10- 
		clr R17						;
		andi temp,0x1F				;  
		rcall bin16_dec5			;  10- 
		ldi YL,LOW(decnum)			;.  X . .   
		clr YH						;
		inc YL						; .    
			;    LCD 
		ld temp,Y					; .  
		tst temp					;   0, 
		breq PC+3					;   
		subi temp, -0x30			;   ASCII-
		rcall lcd_put_char			; .    LCD
		ld temp,-Y					; .  
		subi temp, -0x30			;   ASCII-
		rcall lcd_put_char			; .    LCD
		
		ldi temp,' '				;
		rcall lcd_put_char			; 
		
		sei							; 
		ret
		
;===========================================================================
;		/     LCD 
;---------------------------------------------------------------------------
type_lev: cli
		;    LCD
		POZ_LCD 0,0					;0- , 0- 
		lds temp,level				;     
		
		cpi temp,100				; 4- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg10*2		;.  Z . . " 4"
		rjmp tp_lev					;    /
		
		cpi temp,50					; 3- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg9*2		;.  Z . . " 3"
		rjmp tp_lev					;    /
		
		cpi temp,25					; 2- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg8*2		;.  Z . . " 2"
		rjmp tp_lev					;    /
		
		cpi temp,12					; 1- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg7*2		;.  Z . . " 1"
		rjmp tp_lev					;    /
		
		LOAD_ADDR Z,Messg6*2		;.  Z . . " 0"
		
tp_lev:	rcall Str_LCD				;   
		sei
		ret

;===========================================================================
;		    LCD 
;---------------------------------------------------------------------------
 Prnt_F:		;      
 		cli
		;    LCD
		ldi temp,1				;1- , 1- 
		mov R6,temp				;   
		rcall lcd_X				;    
		ldi R16,1				;
		rcall lcd_Y				;  1- 
		;    
		clr r18					;
		ldi r17,HIGH(870)		;  
		ldi temp,LOW(870)		; : 870  
		add temp,freq			;   
		adc r17,r18				;
		;   10- 
		rcall bin16_dec5		;  10- 
		LOAD_ADDR Y,decnum+3	;.  Y . .   
		;  
		ld temp,Y				; .  
		tst temp				;    0,  -
		brne PC+4				;    
		ldi temp,0x0A			;  
		rcall Dig_x2			;  LCD 
		rjmp PC+2				
		rcall Dig_x2			;  
		
		ld temp,-Y				; .  
		rcall Dig_x2			;  
		
		ld temp,-Y				; .  
		rcall Dig_x2			;  
		
		;  LCD 
		ldI temp,0x20			;   
		rcall lcd_put_char		;
		ldI temp,7				;
		rcall lcd_X				;    
		ldi temp,2				;
		rcall lcd_Y				;  2 
		ldI temp,127			; 
		rcall lcd_put_char		;  LCD 
		
		;  LCD   
		inc R6					;  
		ldI temp,8				;
		rcall lcd_X				;    
		ldi temp,1				;
		rcall lcd_Y				;  1 
		ld temp,-Y				; .  
		rcall Dig_x2			;   
		
		;    ""
	;	POZ_LCD 10,2			;10- , 2- 
	;	LOAD_ADDR Z,Messg4*2	;.  Z . . ""
	;	rcall Str_LCD			;   
		
		sei
		ret
		
;===========================================================================
;    ""
;---------------------------------------------------------------------------
Mono:	;    LCD
		POZ_LCD 13,0				;13- , 0- 
		ldi temp,'M'				;
		rcall lcd_put_char			;  ""  LCD
		cbi PORTB,0					; 
		
		ret
		
;===========================================================================
;    ""
;---------------------------------------------------------------------------
Ster:	;    LCD
		POZ_LCD 13,0				;13- , 0- 
		ldi temp,'S'				;
		rcall lcd_put_char			;  "S"  LCD
		sbi PORTB,0					; 
		
		ret
		
;===========================================================================
; /     0
;---------------------------------------------------------------------------
OVF_T0:	 cli
		push R16          	;   R16
    	in R16,SREG      	;
   		push R16         	;   SREG
		;
		dec time			; 
		
t_1:	tst r1				;     
		breq vyh			;   /,  -
		mov r2,r1			;    
		
vyh:	pop R16          	;   SREG
    	out SREG,R16     	;
    	pop R16          	;   R16
		sei
		reti
		
;===========================================================================
; /     2
;---------------------------------------------------------------------------
OVF_T2:	
		push temp3         	;   temp3
    	in temp3,SREG      	;
   		push temp3         	;   SREG
		;
podsv:	dec R12				; 
		tst R12				;    , -
		brne wyh			;   /,  -
		sbi PORTD,6			;  
		cbi PORTD,7			;  
		ldi temp3,0			;  2
		out TCCR2,temp3		;
		
		sbrs R13,0			;    , 
   		rjmp wyh			;
   		rcall pwr_off		;    
		
		;
wyh:	pop temp3          	;   SREG
    	out SREG,temp3     	;
    	pop temp3          	;   temp3
		
		reti
		
;===========================================================================
;	   
;---------------------------------------------------------------------------
light:	ldi temp,Tm_l				; 
		mov R12,temp				;  
		cbi PORTD,6		 			;  
		sbi PORTD,7					;  
		ldi temp,0b00000111			;
		out TCCR2,temp				;  2   1/1024
		ret
;===========================================================================
;	 /    , ( YH:YL   )
;: YH:YL   	: temp3  
;---------------------------------------------------------------------------
Rd_EP:	cli							; 
		sbic EECR,EEWE				;   
		rjmp PC-1					;
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		sbi EECR,EERE				;  
		in temp3,EEDR				;   . 
		sei							; 
		ret
;===========================================================================
;		    
;: temp3  , YH:YL   
;---------------------------------------------------------------------------
Wr_EP:	cli							; 
		sbic EECR,EEWE				;  
		rjmp PC-1					;   EEWE
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		out EEDR,temp3				;   
		sbi EECR,EEMWE				;   
		sbi EECR,EEWE				;  
		sei							; 
		ret
;===========================================================================
;  2-    5-
;  (  d4d0   SRAM )
;
; R17:R16    ,    (00xFFFF)
; R18,R19,R20   
; [YH:YL]        YH:YL
; decnum      
;---------------------------------------------------------------------------
 bin16_dec5:
 	cli
 	push R18
 	push R19
 	push R20
     ldi   YL,low(decnum) 	;   Y 
     ldi   YH,high(decnum) 	;    d0d4  
     ldi   R20,4    		;   
bd1: clr   R18      		;   R18
     ldi   R19,16   		;    
bd2: lsl   R16      		;   V(D)/10
     rol   R17      		;     R17:R16,
     rol   R18      		;    R18 = di
     andi  R16,0xFE
     cpi   R18,10
     brcs  bd3
     subi  R18,10
     ori   R16,0x01
bd3: dec   R19
     brne  bd2
     st    Y+,R18   		;  di  
     dec   R20
     brne  bd1      		;  n-1 
     st    Y+,R16   		;   dn-1  
    pop R20
    pop R19
    pop R18
     sei
     ret
     
;**************************   ****************************
;===========================================================================
;		/       
;---------------------------------------------------------------------------
U_bat:	cli
		;  
		sbi ADCSR,ADSC			;  
cnv: 	sbis  ADCSR,ADIF		;   ,
     	rjmp  cnv				;   
     	sbi   ADCSR,ADIF		;   
     	in temp,ADCL			; .   
  		sts akkum,temp			;  
		in temp,ADCH			; .   
		sts akkum+1,temp		;  
		
		;    
		sbis PIND,5					;  , 
		rcall U_batt				;    
		
		;    LCD
		POZ_LCD 10,0				;0- ,10- 
		;
		lds temp1,akkum				;    
		lds temp2,akkum+1			;
		
		ldi temp,HIGH(Ubat_3)		; 3- 
		cpi temp1,LOW(Ubat_3)		;
		cpc temp2,temp				;
		brmi PC+4					;
		LOAD_ADDR Z,Messg16*2		;   . " 3"
		rjmp tp_bat					;    /
		
		ldi temp,HIGH(Ubat_2)		; 2- 
		cpi temp1,LOW(Ubat_2)		;
		cpc temp2,temp				;
		brmi PC+4					;
		LOAD_ADDR Z,Messg15*2		;   . " 2"
		rjmp tp_bat					;    /
		
		ldi temp,HIGH(Ubat_1)		; 1- 
		cpi temp1,LOW(Ubat_1)		;
		cpc temp2,temp				;
		brmi PC+4					;
		LOAD_ADDR Z,Messg14*2		;   . " 1"
		rjmp tp_bat					;    /
		
		ldi temp,HIGH(Ubat_0)		; 0- 
		cpi temp1,LOW(Ubat_0)		;
		cpc temp2,temp				;
		brmi avar					;
		LOAD_ADDR Z,Messg13*2		;   . " 0"
		rjmp tp_bat
		
		;  . 
avar:	cbi PORTB,0					; 
		rcall lcd_clr				; LCD
		POZ_LCD 0,1					;1- ,0- 
		LOAD_ADDR Z,Messg17*2		;  . " "
		rcall Str_LCD				; .  
		
		inc R13						;   
		ldi temp,80					;   
		mov R12,temp				; " "
		ldi temp,0b00000111			;  2   1/1024
		out TCCR2,temp				;
		
wt_av:	nop							;  
		rjmp wt_av					;
		
tp_bat:	rcall Str_LCD				;   
		sei
		ret
		
;=========================================================================
;		/   
;---------------------------------------------------------------------------
pwr_off:	
		;   RDA5807
		rcall iic_start				; 
		ldi temp,0x20				;    RDA5807
		rcall IIC_Send				;  
		ldi temp,0b11010010			; - 
		rcall IIC_Send				;(02) = r5
		ldi temp,0					;Power Up =0
		rcall IIC_Send				;  RDA5807
		rcall iic_stop 				; 
		;  
		sbi PORTD,6						;  
		cbi PORTD,7						;  
		cbi PORTB,0						; 
		rcall lcd_clr					; LCD
		ldi temp1,1 					;-  = 1
		cbi LCD_SCE_port,LCD_SCE 		;  (SCE=0)
		cbi LCD_DC_port,LCD_DC 			; D/C =0   
		ldi temp,0x25					; . 
		mov R0,temp						;
		rcall lcd_data					; 1   LCD
		sbi LCD_SCE_port,LCD_SCE		;.  LCD
		
		rcall p_off						; 
		
		;    
		ldi temp1,0b10100000	 		;
		out MCUCR,temp					;  Power down
		sleep							;!
		
		ret
		
;===========================================================================
 p_off:		; 
 		cbi PORTB,PB6				; 
 		DELAY 250					;
		ret
		
;===========================================================================
;		/      LCD  
;---------------------------------------------------------------------------
U_batt:	
		;    LCD
		cli
		POZ_LCD 0,4					;0- , 4- 
		;
		ldi temp,Typ_Bat			; . . ,
		tst temp					;  6...10 ,  -
		brne ur_b					;    2
		
		;     2
		lds temp,akkum				;    
		lds R17,akkum+1				;  
		lsr R17						;   2
		ror temp					;
		rjmp tu_pr					;
		
ur_b:	lds temp,akkum				;   
		lds R17,akkum+1				;  
		
		;  10- 
tu_pr:	rcall bin16_dec5			;  10- 
		ldi YL,LOW(decnum+3)		;.  X . 
		clr YH						; .    
		;     LCD 
		ld temp,Y					;  
		tst temp					;   0, 
		breq bez0					;    
		subi temp, -0x30			;   ASCII-
		rcall lcd_put_char			;    LCD
	
bez0:	ld temp,-Y					;  
		subi temp, -0x30			;   ASCII-
		rcall lcd_put_char			;    LCD
		
		ldi temp,','				;  
		rcall lcd_put_char			;   LCD
		
		ld temp,-Y					;   
		subi temp, -0x30			;   ASCII-
		rcall lcd_put_char			;     LCD
		ld temp,-Y					;   
		subi temp, -0x30			;   ASCII-
		rcall lcd_put_char			;     LCD
		
		ldi temp,'V'				;  c "V"
		rcall lcd_put_char			; c "V"  LCD
	;	ldi temp,' '				;  
	;	rcall lcd_put_char			;   LCD
		sei
		ret
		
;******************************************************************************
	.include "I2C_hard_driver.asm"		;   I2C
 	.include "Driver_DS1307.asm"		;   
 	.include "Driver_DS18B20.asm"		;   DS18B20
 	.include "Driver_N5110_v6.asm"		; LCD Nokia5110
 	.include "User_set.asm"				; 
;******************************************************************************
;==============================================================================
		;     

  Messg1:  .DB  131,131,' ',' ',' ',142,' ',' ',' ',' ',' ',' ',' ',' ', 0,0
  Messg2:  .DB  ' ','','','','','','.',' ','','','','','',' ', 0,0
  Messg3:  .DB  146,146,146,146,146,146,146,146,146,146,146,146,146,146, 0,0
  Messg4:  .DB  '','','',0
  Messg5:  .DB  ' ',' ','','','','','','','','','',' ',' ',' ', 0,0
  Messg6:  .DB  131,131, 0,0		; 0
  Messg7:  .DB  132,131, 0,0		; 1
  Messg8:  .DB  133,131, 0,0		; 2
  Messg9:  .DB  133,134, 0,0		; 3
  Messg10: .DB  133,135, 0,0		; 4
  
  Messg13: .DB  136,137,141, 0		; 0
  Messg14: .DB  136,138,141, 0		; 1
  Messg15: .DB  136,139,141, 0		; 2
  Messg16: .DB  140,139,141, 0		; 3
  Messg17: .DB  "            ", 0,0
  
;-------------------------------------------------------------------------------

	.EXIT

